/**********************************************************************/
/*                                                                    */
/* The server part of a client-server pair.                           */
/*                                                                    */
/**********************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define PORT 6789
#define bufsize 20
#define queuesize 3
#define true 1
#define false 0

int getopt(int argc, char * const argv[], const char *optstring);
extern char *optarg;
extern int optind, opterr, optopt;

void help_msg(char *prog);
void DoService(char *buffer);
int run_popen(char *cmd);

/**********************************************************************/
/* Main                                                               */
/**********************************************************************/

int main (int argc, char *argv[])

{ struct sockaddr_in cin; 
  struct sockaddr_in sin;
  struct hostent *hp;
  char buffer[bufsize];
  int sd, sd_client, addrlen;
  int portno;
  int c;
  FILE *fp;
  char s[200];

  portno=PORT;

//parse command line parameters
while ((c=getopt(argc,argv,"p")) != EOF)
   {
     switch(c)
       {
       case 'p':
         portno = atoi(argv[optind]);
         //(void) fprintf(stdout,"port #: %d \n",portno);
         break;
       default:
         help_msg(argv[0]);
         return (-1);
       }
  }

fprintf(stdout,"Server on port : %d\n",portno);

memset(&sin,0,sizeof(sin));       /* Another way to zero memory */
sin.sin_family = AF_INET;
sin.sin_addr.s_addr = INADDR_ANY;          /* Broadcast address */
sin.sin_port = htons(portno);

if ((sd = socket(AF_INET,SOCK_STREAM,0)) == -1)
   {
   perror("socket");
   exit(1);
   }

if (bind(sd,(struct sockaddr *)&sin,sizeof(sin)) == -1)  /* Must have this on server */
   {
   perror("bind");
   exit(1);
   }

if (listen(sd,queuesize) == -1)
   {
   perror("listen");
   exit(1);
   }

while (true)
  {
  if ((sd_client = accept(sd,(struct sockaddr *)&cin,&addrlen)) == -1)
      {
      perror("accept");
      exit(1);
      }

//   if (recv(sd_client,buffer,sizeof(buffer),0) == -1)
//      {
//      perror("recv");
//      exit(1);
//      }

//treat socket as file to avoid messed characters
     fp=fdopen(sd_client,"r+");    
     while(fgets(s,sizeof(s),fp)!=0 && strcmp(s,"quit")!=0)
     {
	DoService(s);
     }
     if(strcmp(s,"quit")==0){
	fclose(fp);
	close (sd_client);
	break;
     }
     fclose(fp);


//   if (send(sd_client,buffer,strlen(buffer),0) == -1)
//      {
//      perror("send");
//      exit(1);
//      }

   close (sd_client);
}

close (sd);
printf("Server closing down...\n");
}

/**************************************************************/

//popen to run script
int run_popen(char *cmd){
FILE *fp;
char line[130];

fp = popen(cmd, "r");
while ( fgets( line, sizeof line, fp))
    {
    printf("%s", line);
    }
pclose(fp);
return 1;
}

void DoService(char *buffer)
{
   char cmd[200];

   printf("Received data: %s\n",buffer);
   strcpy(cmd,"/bin/sh  /home/ycai/ddos/httperf-0.8/auto.sh");
   run_popen(cmd);
}

void help_msg(char *prog)
{
  fprintf(stdout,"Usage : %s -p <port no> \n", prog);
  fprintf(stdout, "Deafult port: %d \n",PORT);
  return;
}

